<?
  class Users
  {
	  public function Run($parts)
	  {
		  $action = array_pop($parts);
		  if ( !strcmp((int)$action, $action))
		  {
			  $id = $action;
			  $action = "view";
		  }
		  $methodName = ucfirst($action)."Action";
		  if (method_exists($this, $methodName))
		  	return $this->$methodName($parts);
	  }
	  public function RegisterAction($parts)
	  {
		  if (isset($_SESSION['user']))
		  	return;
		  if (isset($_POST['user_login']))
		  {
			  $arr = array_form_filter($_POST, array("user_login", "user_password", "user_name"));
			  $count = DB::Count("users", array("user_login" => $arr["user_login"]));
			  if (DB::Count("users", array("user_login" => $arr["user_login"])) == 0)
			  {
				 DB::Insert("users", $arr);  
				 header("Location: /users/register/success");
				 die;
			  } else
			  {
				  $error = "Пользователь с таким логином уже существует";
			  }
		  }
		  $title = "Регистрация пользователей";
		  $tpl = new Template("design/Users/register.tpl");
		  $tpl->SetParam("error", $error);
		  $html = $tpl->GetContent();
		  return array("pageTitle" => $title, "pageContent" => $html);
	  }
	  public function SuccessAction($parts)
	  {
		  $title = "Успешная регистрация";
		  $tpl = new Template("design/Users/success.tpl");
		  return array("pageTitle" => $title, "pageContent" => $tpl->GetContent());
	  }
	  public function ListAction($parts)
	  {
		  $title = "Список пользователей";
		  $tpl = new Template("design/Users/list.tpl");
		  $users = DB::Select("users");
		  $tpl->SetParam("users", $users);
		  		  
		  return array("pageTitle" => $title, "pageContent" => $tpl->GetContent());
	  }
 	 public function ProfileAction($parts)
	  {
		  if (!isset($_SESSION['user']))
		  	return;
		  if ($_SERVER['REQUEST_METHOD'] == "POST")
		  {
			  $rows = array_form_filter($_POST, array("user_name", "user_surname", "user_about"));
			  if (is_file($_FILES['user_avatar']['tmp_name']))
			  {
				  if (is_file($_SESSION['user']['user_avatar']))
				  	unlink($_SESSION['user']['user_avatar']);
				  $path = "data/Users/".uniqid().".jpg";
				  move_uploaded_file($_FILES['user_avatar']['tmp_name'], $path);
				  $rows['user_avatar'] = $path;
			  }
			  
			  if ($_SESSION['user']['user_password'] == $_POST['user_password_old'] && $_POST['user_password'] == $_POST['user_password2'])
				  $rows['user_password'] = $_POST['user_password']; 
			  DB::Update("users", $rows, array("user_id" => $_SESSION['user']['user_id']));
			  $r = DB::Select("users", "*", array("user_id" => $_SESSION['user']['user_id']));
			  $_SESSION['user'] = $r[0];
		  }
		  $title = "Редактирование профиля";
		  $tpl = new Template("design/Users/profile.tpl");
		  $rows = DB::Select("users", "*", array("user_id" => $_SESSION['user']['user_id']));
		  $tpl->SetArrayParam($rows[0]);
		  return array("pageTitle" => $title, "pageContent" => $tpl->GetContent());
	  }
	  public function LoginAction($parts)
	  {
		  if (isset($_SESSION['user']))
		  	return;
		  if ($_SERVER['REQUEST_METHOD'] == "POST")
		  {
			  $rows = array_form_filter($_POST, array("user_login", "user_password"));
			  if (DB::Count("users", $rows))
			  {
				  $r = DB::Select("users", "*", $rows);
				  $_SESSION['user'] = $r[0];
				  header("Location: /");
				  die;
			  }
		  }
		  $title = "Успешная регистрация";
		  $tpl = new Template("design/Users/login.tpl");
		  return array("pageTitle" => $title, "pageContent" => $tpl->GetContent());
	  }
	  public function LogoutAction($parts)
	  {
		  unset($_SESSION['user']);
	  }
	  public static function GetPanel()
	  {
		  if (isset($_SESSION['user']))
		  {
			  $tpl = new Template("design/users/user-panel.tpl");
			  return $tpl->GetContent();
		  }
		  else
		  {
			  $tpl = new Template("design/users/guest-panel.tpl");
			  return $tpl->GetContent();
		  }
	  }
	
  }
?>